import torch
import matplotlib.pyplot as plt

fig = plt.figure()
# Plot
ax = fig.add_subplot(111)

VarFile="./Loss_%s_log_32_44_init_1_epoch_99999.pt" % "const"
X=torch.load(VarFile)

print(X.size())

print(X[:,-1])

for i in range(X.size()[0]):
    ax.plot(torch.log2(torch.arange(1,X.size()[1]+1,1.)),(X[i,:]),label=r"$\zeta=2^{-%.1f}$" % ((32+2*i)/4) )

#ax.set_xlim(5,17)
#ax.set_ylim(-12.5,-6.5)

xt=torch.arange(6,17,1)
xttext=[]
for t in xt:
    xttext.append(r"$2^{%d}$" % t)
    
yt=torch.arange(-12,-7,1)
yttext=[]
for t in yt:
    yttext.append(r"$2^{%d}$" % t)

#ax.set_xticks(xt)
#ax.set_xticklabels(xttext)
#ax.set_yticks(yt)
#ax.set_yticklabels(yttext)

plt.xlabel("iteration")
plt.ylabel("Loss")

plt.legend()
plt.show()
plt.savefig('loss.eps', format='eps')