from torch import nn
import torch.nn.functional as F
import torch
import math
            
class Net(nn.Module):

    def __init__(self, xdim=100, hdim=200):
	
        self.xdim = xdim
        self.hdim = hdim

        super(Net,self).__init__()

        self.fc = nn.Linear(xdim,hdim).cuda()
        #self.fc.bias.data.fill_(0.)
        for p in self.parameters():
            p.requires_grad=False

            
    def forward(self,x0):

        x = x0/x0.norm()
        
        return torch.sin(self.fc(x)).norm()**2

def run(vec, net,lr, train=True):
    
    G=torch.zeros(1)
    
    if train==True:
        L = net(vec)
        L.backward(retain_graph=True)
        #print(vec.grad[1])
        G = vec.grad.norm()
        #print(G)
        with torch.no_grad():
            vec.copy_(vec-lr*(vec.grad+0.1*torch.randn_like(vec)/(self.xdim**.5)))
            vec.copy_(vec/vec.norm())
        vec.grad.zero_()
        
    if train==False:
        with torch.no_grad():
            L = net(vec)

    return L.detach(), G.detach()
