import torch
import matplotlib.pyplot as plt

fig = plt.figure()
# Plot
ax = fig.add_subplot(111)

xt=torch.arange(0,16,2)
xttext=[]
for t in xt:
    xttext.append(r"$2^{%d}$" % t)
ax.set_xticks(xt)
ax.set_xticklabels(xttext)
ax.set_xlabel("#epoch")

s = ("11","22","12")
#l = ("$V_{11}(t)$","$V_22(t)$","$V_12(t)$")
for i in range(3):
    VarFile="./Weight_%s_log_18_init_%s_epoch_39999_pairvar.pt" % ("const",s[i])
    X=torch.load(VarFile)
    ax.plot(torch.log2(torch.arange(1,X.size()[0]+1,1.)),X,label=r"$V_{%s}(t)$" % s[i])

"""
for i in range(X.size()[0]):
    ax.plot(torch.log2(torch.arange(1,X.size()[1]+1,1.)),(X[i,:]),label=r"LR=$2^{-%.2f}$" % ((28+4*i)/4) )
"""


plt.legend()
plt.show()
#plt.savefig('var.png', format='png')